diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/examples/ping-example.cc ns-3.47/src/internet-apps/examples/ping-example.cc
--- ns-3.46/src/internet-apps/examples/ping-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/examples/ping-example.cc	2026-02-16 16:08:49.603230000 -0800
@@ -6,60 +6,66 @@
  * Author: Chandrakant Jena <chandrakant.barcelona@gmail.com>
  */
 
-// Example to demonstrate the working of the Ping Application
-// Network topology:
-// A ------------------------------ B ------------------------------ C
-//             100 Mbps                           100 Mbps
-//               5 ms (one way)                     5 ms (one way)
-// IPv4 addresses:
-// 10.1.1.1    <->         10.1.1.2 / 10.1.2.1     <->         10.1.2.2
-//
-// IPv6 addresses:
-// 2001:1::200:ff:fe00:1
-//     <->    2001:1::200:ff:fe00:2 / 2001:1:0:1:200:ff:fe00:3
-//                                       <-> 2001:1:0:1:200:ff:fe00:4
-//
-// The topology has three nodes interconnected by two point-to-point links.
-// Each link has 5 ms one-way delay, for a round-trip propagation delay
-// of 20 ms.  The transmission rate on each link is 100 Mbps.  The routing
-// between links is enabled by ns-3's NixVector routing.
-//
-// By default, this program will send 5 pings from node A to node C using IPv6.
-// When using IPv6, the output will look like this:
-//
-// PING 2001:1:0:1:200:ff:fe00:4 - 56 bytes of data; 104 bytes including ICMP and IPv6 headers.
-// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=0 ttl=63 time=20.033 ms
-// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=1 ttl=63 time=20.033 ms
-// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=2 ttl=63 time=20.033 ms
-// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=3 ttl=63 time=20.033 ms
-// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=4 ttl=63 time=20.033 ms
-//
-// --- 2001:1:0:1:200:ff:fe00:4 ping statistics ---
-// 5 packets transmitted, 5 received, 0% packet loss, time 4020ms
-// rtt min/avg/max/mdev = 20/20/20/0 ms
-//
-// When using IPv4, the output will look like this:
-//
-//   PING 10.1.2.2 - 56 bytes of data; 84 bytes including ICMP and IPv4 headers.
-//   64 bytes from (10.1.2.2): icmp_seq=0 ttl=63 time=20.027 ms
-//   64 bytes from (10.1.2.2): icmp_seq=1 ttl=63 time=20.027 ms
-//   64 bytes from (10.1.2.2): icmp_seq=2 ttl=63 time=20.027 ms
-//   64 bytes from (10.1.2.2): icmp_seq=3 ttl=63 time=20.027 ms
-//   64 bytes from (10.1.2.2): icmp_seq=4 ttl=63 time=20.027 ms
-//   --- 10.1.2.2 ping statistics ---
-//   5 packets transmitted, 5 received, 0% packet loss, time 4020ms
-//   rtt min/avg/max/mdev = 20/20/20/0 ms
-//
-// The example program will also produce four pcap traces (one for each
-// NetDevice in the scenario) that can be viewed using tcpdump or Wireshark.
-//
-// Other program options include options to change the destination and
-// source addresses, number of packets (count), packet size, interval,
-// and whether to enable logging (if logging is enabled in the build).
-//
-// The Ping application in this example starts at simulation time 1 and will
-// stop either at simulation time 50 or once 'Count' pings have been responded
-// to, whichever comes first.
+/**
+ * @file
+ * Example to demonstrate the working of the Ping Application
+ * Network topology:
+ * @verbatim
+   A ------------------------------ B ------------------------------ C
+               100 Mbps                           100 Mbps
+                 5 ms (one way)                     5 ms (one way)
+   IPv4 addresses:
+   10.1.1.1    <->         10.1.1.2 / 10.1.2.1     <->         10.1.2.2
+
+   IPv6 addresses:
+   2001:1::200:ff:fe00:1
+       <->    2001:1::200:ff:fe00:2 / 2001:1:0:1:200:ff:fe00:3
+                                          <-> 2001:1:0:1:200:ff:fe00:4
+   @endverbatim
+ *
+ * The topology has three nodes interconnected by two point-to-point links.
+ * Each link has 5 ms one-way delay, for a round-trip propagation delay
+ * of 20 ms.  The transmission rate on each link is 100 Mbps.  The routing
+ * between links is enabled by ns-3's NixVector routing.
+ *
+ * By default, this program will send 5 pings from node A to node C using IPv6.
+ * When using IPv6, the output will look like this:
+ * @verbatim
+   PING 2001:1:0:1:200:ff:fe00:4 - 56 bytes of data; 104 bytes including ICMP and IPv6 headers.
+   64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=0 ttl=63 time=20.033 ms
+   64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=1 ttl=63 time=20.033 ms
+   64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=2 ttl=63 time=20.033 ms
+   64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=3 ttl=63 time=20.033 ms
+   64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=4 ttl=63 time=20.033 ms
+   --- 2001:1:0:1:200:ff:fe00:4 ping statistics ---
+   5 packets transmitted, 5 received, 0% packet loss, time 4020ms
+   rtt min/avg/max/mdev = 20/20/20/0 ms
+   @endverbatim
+ *
+ * When using IPv4, the output will look like this:
+ * @verbatim
+   PING 10.1.2.2 - 56 bytes of data; 84 bytes including ICMP and IPv4 headers.
+   64 bytes from (10.1.2.2): icmp_seq=0 ttl=63 time=20.027 ms
+   64 bytes from (10.1.2.2): icmp_seq=1 ttl=63 time=20.027 ms
+   64 bytes from (10.1.2.2): icmp_seq=2 ttl=63 time=20.027 ms
+   64 bytes from (10.1.2.2): icmp_seq=3 ttl=63 time=20.027 ms
+   64 bytes from (10.1.2.2): icmp_seq=4 ttl=63 time=20.027 ms
+   --- 10.1.2.2 ping statistics ---
+   5 packets transmitted, 5 received, 0% packet loss, time 4020ms
+   rtt min/avg/max/mdev = 20/20/20/0 ms
+   @endverbatim
+ *
+ * The example program will also produce four pcap traces (one for each
+ * NetDevice in the scenario) that can be viewed using tcpdump or Wireshark.
+ *
+ * Other program options include options to change the destination and
+ * source addresses, number of packets (count), packet size, interval,
+ * and whether to enable logging (if logging is enabled in the build).
+ *
+ * The Ping application in this example starts at simulation time 1 and will
+ * stop either at simulation time 50 or once 'Count' pings have been responded
+ * to, whichever comes first.
+ */
 
 #include "ns3/core-module.h"
 #include "ns3/internet-apps-module.h"
@@ -69,6 +75,7 @@
 #include "ns3/point-to-point-module.h"
 
 #include <fstream>
+#include <optional>
 
 using namespace ns3;
 
@@ -86,6 +93,10 @@
     std::string sourceStr;
     Address source;
     bool useIpv6{true};
+    std::optional<Ipv4Address> v4Dst;
+    std::optional<Ipv6Address> v6Dst;
+    std::optional<Ipv4Address> v4Src;
+    std::optional<Ipv6Address> v6Src;
 
     GlobalValue::Bind("ChecksumEnabled", BooleanValue(true));
 
@@ -104,39 +115,48 @@
 
     if (!destinationStr.empty())
     {
-        Ipv4Address v4Dst(destinationStr.c_str());
-        Ipv6Address v6Dst(destinationStr.c_str());
-        if (v4Dst.IsInitialized())
+        if (Ipv4Address::CheckCompatible(destinationStr))
         {
+            v4Dst = Ipv4Address(destinationStr.c_str());
             useIpv6 = false;
-            destination = v4Dst;
+            destination = v4Dst.value();
         }
-        else if (v6Dst.IsInitialized())
+        else if (Ipv6Address::CheckCompatible(destinationStr))
         {
+            v6Dst = Ipv6Address(destinationStr.c_str());
             useIpv6 = true;
-            destination = v6Dst;
+            destination = v6Dst.value();
+        }
+        else
+        {
+            NS_ABORT_MSG("Can't parse destination address " << destinationStr);
         }
     }
 
     if (!sourceStr.empty())
     {
-        Ipv4Address v4Src(sourceStr.c_str());
-        Ipv6Address v6Src(sourceStr.c_str());
-        if (v4Src.IsInitialized())
+        if (Ipv4Address::CheckCompatible(sourceStr))
         {
-            source = v4Src;
+            v4Src = Ipv4Address(sourceStr.c_str());
+            useIpv6 = false;
+            source = v4Src.value();
         }
-        else if (v6Src.IsInitialized())
+        else if (Ipv6Address::CheckCompatible(sourceStr))
+        {
+            v6Src = Ipv6Address(sourceStr.c_str());
+            useIpv6 = true;
+            source = v6Src.value();
+        }
+        else
         {
-            source = v6Src;
+            NS_ABORT_MSG("Can't parse destination address " << destinationStr);
         }
     }
     if (sourceStr.empty())
     {
         if (useIpv6)
         {
-            Ipv6Address v6Dst = Ipv6Address(destinationStr.c_str());
-            if (v6Dst.IsInitialized() && v6Dst.IsMulticast())
+            if (v6Dst && v6Dst->IsMulticast())
             {
                 std::cout << "Specify a source address to use when pinging multicast addresses"
                           << std::endl;
@@ -146,8 +166,7 @@
         }
         else
         {
-            Ipv4Address v4Dst(destinationStr.c_str());
-            if (v4Dst.IsInitialized() && (v4Dst.IsBroadcast() || v4Dst.IsMulticast()))
+            if (v4Dst && (v4Dst->IsBroadcast() || v4Dst->IsMulticast()))
             {
                 std::cout << "Specify a source address to use when pinging broadcast or multicast "
                              "addresses"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-client.cc ns-3.47/src/internet-apps/model/dhcp6-client.cc
--- ns-3.46/src/internet-apps/model/dhcp6-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-client.cc	2026-02-16 16:08:49.604230000 -0800
@@ -12,6 +12,7 @@
 #include "dhcp6-duid.h"
 
 #include "ns3/address-utils.h"
+#include "ns3/enum.h"
 #include "ns3/icmpv6-l4-protocol.h"
 #include "ns3/ipv6-interface.h"
 #include "ns3/ipv6-l3-protocol.h"
@@ -71,6 +72,23 @@
                           TimeValue(Seconds(100)),
                           MakeTimeAccessor(&Dhcp6Client::m_solicitInterval),
                           MakeTimeChecker())
+            .AddAttribute("DuidType",
+                          "Configure the type of DUID used by the client.",
+                          EnumValue(Duid::Type::LL),
+                          MakeEnumAccessor<Duid::Type>(&Dhcp6Client::m_duidType),
+                          MakeEnumChecker(Duid::Type::LLT,
+                                          "LLT",
+                                          Duid::Type::EN,
+                                          "EN",
+                                          Duid::Type::LL,
+                                          "LL",
+                                          Duid::Type::UUID,
+                                          "UUID"))
+            .AddAttribute("DuidEnIdentifierLength",
+                          "Length of the identifier of the DUID-EN.",
+                          IntegerValue(8),
+                          MakeIntegerAccessor(&Dhcp6Client::m_DuidEnIdentifierLength),
+                          MakeIntegerChecker<uint16_t>(4, 65529))
             .AddTraceSource("NewLease",
                             "The client has obtained a lease",
                             MakeTraceSourceAccessor(&Dhcp6Client::m_newLease),
@@ -213,8 +231,6 @@
 
 Dhcp6Client::InterfaceConfig::~InterfaceConfig()
 {
-    std::cout << "InterfaceConfig::~InterfaceConfig" << std::endl;
-
     m_socket = nullptr;
     m_client = nullptr;
 
@@ -253,7 +269,6 @@
 
         // Notify the new lease.
         m_client->m_newLease(offeredAddress);
-        std::cerr << "* got a new lease " << offeredAddress << std::endl;
     }
 }
 
@@ -873,10 +888,17 @@
     int32_t ifIndex = ipv6->GetInterfaceForDevice(device);
     Ptr<InterfaceConfig> dhcpInterface = m_interfaces[ifIndex];
 
-    Ptr<Node> node = GetNode();
     if (m_clientDuid.IsInvalid())
     {
-        m_clientDuid.Initialize(node);
+        Ptr<Node> node = GetNode();
+        // We use enterprise-number 0xf00dcafe (totally arbitrary)
+        // The current largest enterprise number is less than 0xffff, which means
+        // we use an unused number.
+        // The list of numbers is at
+        // https://www.iana.org/assignments/enterprise-numbers/
+
+        m_clientDuid.Initialize(m_duidType, node, m_DuidEnIdentifierLength);
+        NS_LOG_INFO("DHCPv6 client DUID created: " << m_clientDuid);
     }
 
     Dhcp6Header header;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-client.h ns-3.47/src/internet-apps/model/dhcp6-client.h
--- ns-3.46/src/internet-apps/model/dhcp6-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-client.h	2026-02-16 16:08:49.604230000 -0800
@@ -68,6 +68,7 @@
     void StartApplication() override;
     void StopApplication() override;
 
+  private:
     /**
      * @ingroup dhcp6
      *
@@ -232,6 +233,9 @@
 
     /**
      * @brief Used to send the Solicit message and start the DHCPv6 client.
+     *
+     * This function also builds the client's DUID on first invocation.
+     *
      * @param device The client interface.
      */
     void Boot(Ptr<NetDevice> device);
@@ -245,11 +249,10 @@
     /// Map each interface to its corresponding configuration details.
     std::unordered_map<uint32_t, Ptr<InterfaceConfig>> m_interfaces;
 
-    Duid m_clientDuid;                             //!< The client DUID.
     TracedCallback<const Ipv6Address&> m_newLease; //!< Trace the new lease.
 
     /// Track the IPv6 Address - IAID association.
-    std::unordered_map<Ipv6Address, uint32_t, Ipv6AddressHash> m_iaidMap;
+    std::unordered_map<Ipv6Address, uint32_t> m_iaidMap;
 
     /// Random variable to set transaction ID
     Ptr<RandomVariableStream> m_transactionId;
@@ -264,6 +267,16 @@
 
     /// Random variable used to create the IAID.
     Ptr<RandomVariableStream> m_iaidStream;
+
+    Duid::Type m_duidType;             //!< DUID type.
+    uint16_t m_DuidEnIdentifierLength; //!< DUID-EN identifier length.
+
+    /**
+     * The client DUID, built on first usage in the Boot() function.
+     * We avoid to use `StartApplication()` to randomize the time
+     * of DUID-LLT.
+     */
+    Duid m_clientDuid;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-duid.cc ns-3.47/src/internet-apps/model/dhcp6-duid.cc
--- ns-3.46/src/internet-apps/model/dhcp6-duid.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-duid.cc	2026-02-16 16:08:49.604230000 -0800
@@ -15,66 +15,32 @@
 #include "ns3/log.h"
 #include "ns3/loopback-net-device.h"
 #include "ns3/ptr.h"
+#include "ns3/simulator.h"
+
+#include <algorithm>
+#include <iomanip>
 
 namespace ns3
 {
 
 NS_LOG_COMPONENT_DEFINE("Dhcp6Duid");
 
-Duid::Duid()
-{
-    m_duidType = Duid::Type::LL;
-    m_hardwareType = 0;
-    m_time = Time();
-    m_identifier = std::vector<uint8_t>();
-}
-
-bool
-Duid::operator==(const Duid& o) const
-{
-    return (m_duidType == o.m_duidType && m_hardwareType == o.m_hardwareType &&
-            m_identifier == o.m_identifier);
-}
-
-bool
-operator<(const Duid& a, const Duid& b)
-{
-    if (a.m_duidType < b.m_duidType)
-    {
-        return true;
-    }
-    else if (a.m_duidType > b.m_duidType)
-    {
-        return false;
-    }
-    if (a.m_hardwareType < b.m_hardwareType)
-    {
-        return true;
-    }
-    else if (a.m_hardwareType > b.m_hardwareType)
-    {
-        return false;
-    }
-    NS_ASSERT(a.GetLength() == b.GetLength());
-    return a.m_identifier < b.m_identifier;
-}
-
 bool
 Duid::IsInvalid() const
 {
-    return m_identifier.empty();
+    return m_blob.empty();
 }
 
 uint8_t
 Duid::GetLength() const
 {
-    return m_identifier.size();
+    return m_blob.size();
 }
 
 std::vector<uint8_t>
 Duid::GetIdentifier() const
 {
-    return m_identifier;
+    return m_blob;
 }
 
 Duid::Type
@@ -84,59 +50,135 @@
 }
 
 void
-Duid::SetDuidType(Duid::Type duidType)
+Duid::InitializeLL(Ptr<Node> node)
 {
-    m_duidType = duidType;
+    NS_LOG_FUNCTION(this << node);
+
+    m_duidType = Type::LL;
+    Address duidAddress = FindSuitableNetDeviceAddress(node);
+
+    uint8_t idLen = duidAddress.GetLength();
+    NS_ASSERT_MSG(idLen == 6 || idLen == 8, "Duid: Invalid identifier length.");
+
+    m_blob.resize(idLen + Offset::LL);
+
+    // Ethernet (48 bit) - HardwareType 1
+    // EUI-64 (64 bit) - HardwareType 27
+    m_blob[0] = 0;
+    m_blob[1] = idLen == 6 ? 1 : 27;
+
+    duidAddress.CopyTo(&m_blob[Offset::LL]);
 }
 
-uint16_t
-Duid::GetHardwareType() const
+void
+Duid::InitializeLLT(Ptr<Node> node)
 {
-    return m_hardwareType;
+    NS_LOG_FUNCTION(this << node);
+
+    m_duidType = Type::LLT;
+    Address duidAddress = FindSuitableNetDeviceAddress(node);
+
+    uint8_t idLen = duidAddress.GetLength();
+    NS_ASSERT_MSG(idLen == 6 || idLen == 8, "Duid: Invalid identifier length.");
+
+    m_blob.resize(idLen + Offset::LLT);
+
+    // Ethernet (48 bit) - HardwareType 1
+    // EUI-64 (64 bit) - HardwareType 27
+    m_blob[0] = 0;
+    m_blob[1] = idLen == 6 ? 1 : 27;
+
+    // This should be (according to RFC 8415)
+    // seconds since midnight (UTC), January 1, 2000, modulo 2 ^ 32
+    // We do not have an (easy) way to measure the difference.
+
+    uint32_t time = std::floor(std::fmod(Simulator::Now().GetSeconds(), std::pow(2, 32)));
+    HtoN(time, m_blob.begin() + Offset::LL);
+
+    duidAddress.CopyTo(&m_blob[Offset::LLT]);
 }
 
 void
-Duid::SetHardwareType(uint16_t hardwareType)
+Duid::InitializeEN(uint32_t enNumber, const std::vector<uint8_t>& identifier)
 {
-    NS_LOG_FUNCTION(this << hardwareType);
-    m_hardwareType = hardwareType;
+    NS_LOG_FUNCTION(this << enNumber << identifier);
+
+    m_duidType = Type::EN;
+
+    // The DUID is going to be embedded in an option, which
+    // have a DUID length expressed 16-bit
+    // this leaves 65535 - 2 - 4 bytes for the identifier.
+    NS_ASSERT_MSG(identifier.size() < 65535 - 6,
+                  "Duid: Invalid identifier length (max length is 65529 bytes).");
+
+    m_blob.resize(identifier.size() + Offset::EN);
+
+    HtoN(enNumber, m_blob.begin());
+
+    std::move(identifier.cbegin(), identifier.cend(), &m_blob[Offset::EN]);
 }
 
 void
-Duid::SetDuid(std::vector<uint8_t> identifier)
+Duid::InitializeUUID(const std::vector<uint8_t>& uuid)
 {
-    NS_LOG_FUNCTION(this << identifier);
+    NS_LOG_FUNCTION(this << uuid);
 
-    m_duidType = Type::LL;
-    uint8_t idLen = identifier.size();
+    m_duidType = Type::UUID;
 
-    NS_ASSERT_MSG(idLen == 6 || idLen == 8, "Duid: Invalid identifier length.");
+    NS_ASSERT_MSG(uuid.size() == 16, "Duid: Invalid identifier length (UUID must be 128 bits).");
+
+    m_blob.resize(uuid.size());
+
+    std::move(uuid.cbegin(), uuid.cend(), m_blob.begin());
+}
+
+void
+Duid::Initialize(Type duidType, Ptr<Node> node, uint32_t enIdentifierLength)
+{
+    NS_LOG_FUNCTION(this << std::to_underlying(duidType) << node << enIdentifierLength);
 
-    switch (idLen)
+    switch (duidType)
     {
-    case 6:
-        // Ethernet - 48 bit length
-        SetHardwareType(1);
+    case Duid::Type::LLT: {
+        InitializeLLT(node);
         break;
-    case 8:
-        // EUI-64 - 64 bit length
-        SetHardwareType(27);
+    }
+    case Duid::Type::EN: {
+        // We use enterprise-number 0xf00dcafe (totally arbitrary)
+        // The list of numbers is at
+        // https://www.iana.org/assignments/enterprise-numbers/
+        std::vector<uint8_t> identifier(enIdentifierLength);
+        HtoN(node->GetId(), identifier.begin());
+        InitializeEN(0xf00dcafe, identifier);
         break;
     }
-
-    m_identifier.resize(idLen);
-    m_identifier = identifier;
+    case Duid::Type::LL: {
+        InitializeLL(node);
+        break;
+    }
+    case Duid::Type::UUID: {
+        std::vector<uint8_t> identifier(16);
+        HtoN(node->GetId(), identifier.begin());
+        InitializeUUID(identifier);
+        break;
+    }
+    }
 }
 
-void
-Duid::Initialize(Ptr<Node> node)
+Address
+Duid::FindSuitableNetDeviceAddress(Ptr<Node> node)
 {
+    NS_LOG_FUNCTION(this << node);
+
     Ptr<Ipv6L3Protocol> ipv6 = node->GetObject<Ipv6L3Protocol>();
+    NS_ASSERT_MSG(ipv6, "DHCPv6: No IPv6 stack found.");
     uint32_t nInterfaces = ipv6->GetNInterfaces();
 
     uint32_t maxAddressLength = 0;
     Address duidAddress;
 
+    // We select NetDevices with the longest MAC address length,
+    // and among them, the one with the smallest index.
     for (uint32_t i = 0; i < nInterfaces; i++)
     {
         Ptr<NetDevice> device = ipv6->GetNetDevice(i);
@@ -164,32 +206,14 @@
 
     NS_LOG_DEBUG("DUID of node " << node->GetId() << " is " << duidAddress);
 
-    // Consider the link-layer address of the first NetDevice in the list.
-    uint8_t buffer[16];
-    duidAddress.CopyTo(buffer);
-
-    std::vector<uint8_t> identifier(duidAddress.GetLength());
-    std::copy(buffer, buffer + duidAddress.GetLength(), identifier.begin());
-    SetDuid(identifier);
-}
-
-Time
-Duid::GetTime() const
-{
-    return m_time;
-}
-
-void
-Duid::SetTime(Time time)
-{
-    NS_LOG_FUNCTION(this << time);
-    m_time = time;
+    return duidAddress;
 }
 
 uint32_t
 Duid::GetSerializedSize() const
 {
-    return 4 + m_identifier.size();
+    // The DUID type is 2 bytes.
+    return 2 + m_blob.size();
 }
 
 void
@@ -197,12 +221,8 @@
 {
     Buffer::Iterator i = start;
     i.WriteHtonU16(static_cast<std::underlying_type_t<Duid::Type>>(m_duidType));
-    i.WriteHtonU16(m_hardwareType);
 
-    for (const auto& byte : m_identifier)
-    {
-        i.WriteU8(byte);
-    }
+    i.Write(&m_blob[0], m_blob.size());
 }
 
 uint32_t
@@ -211,15 +231,21 @@
     Buffer::Iterator i = start;
 
     m_duidType = static_cast<Duid::Type>(i.ReadNtohU16());
-    m_hardwareType = i.ReadNtohU16();
-    m_identifier.resize(len);
+    len -= 2;
 
-    for (uint32_t j = 0; j < len; j++)
-    {
-        m_identifier[j] = i.ReadU8();
-    }
+    m_blob.resize(len);
+    i.Read(&m_blob[0], m_blob.size());
+
+    return GetSerializedSize();
+}
 
-    return 4 + m_identifier.size();
+void
+Duid::HtoN(uint32_t source, std::vector<uint8_t>::iterator dest)
+{
+    dest[0] = (source >> 24);
+    dest[1] = (source >> 16) & 0xFF;
+    dest[2] = (source >> 8) & 0xFF;
+    dest[3] = source & 0xFF;
 }
 
 size_t
@@ -231,4 +257,84 @@
     std::string s(buffer.begin(), buffer.begin() + duidLen);
     return std::hash<std::string>{}(s);
 }
+
+// Comparison operators are defined because gcc-13.3 raises an error in optimized builds.
+// Other than that, the comparisons are semantically identical to the default ones.
+bool
+Duid::operator==(const Duid& other) const
+{
+    return std::is_eq(*this <=> other);
+};
+
+std::strong_ordering
+operator<=>(const Duid& a, const Duid& b)
+{
+    if (a.m_duidType == b.m_duidType)
+    {
+        return a.m_blob <=> b.m_blob;
+    }
+
+    return a.m_duidType <=> b.m_duidType;
+}
+
+std::ostream&
+operator<<(std::ostream& os, const Duid& duid)
+{
+    auto fold16 = [](std::vector<uint8_t>::const_iterator a) -> uint16_t {
+        auto f = static_cast<uint16_t>(a[0]) << 8;
+        f += static_cast<uint16_t>(a[1]);
+        return f;
+    };
+
+    auto fold32 = [](std::vector<uint8_t>::const_iterator a) -> uint32_t {
+        auto f = static_cast<uint32_t>(a[0]) << 24;
+        f += static_cast<uint32_t>(a[1]) << 16;
+        f += static_cast<uint32_t>(a[2]) << 8;
+        f += static_cast<uint32_t>(a[3]);
+        return f;
+    };
+
+    auto format = [](std::vector<uint8_t>::const_iterator start,
+                     std::vector<uint8_t>::const_iterator end) -> std::string {
+        std::ostringstream str;
+        str << std::hex;
+        std::for_each(start, end, [&](int i) { str << std::setfill('0') << std::setw(2) << i; });
+        return str.str();
+    };
+
+    switch (duid.m_duidType)
+    {
+    case Duid::Type::LLT: {
+        os << "DUID-LLT";
+        os << " HWtype: " << fold16(duid.m_blob.cbegin());
+        os << " Time: " << fold32(duid.m_blob.cbegin() + 2);
+        auto identifierStart = duid.m_blob.cbegin() + Duid::Offset::LLT;
+        os << " Identifier: 0x" << format(identifierStart, duid.m_blob.cend());
+        break;
+    }
+    case Duid::Type::EN: {
+        os << "DUID-EN";
+        os << " EnNumber: 0x"
+           << format(duid.m_blob.cbegin(), duid.m_blob.cbegin() + Duid::Offset::EN);
+        auto identifierStart = duid.m_blob.cbegin() + Duid::Offset::EN;
+        os << " Identifier: 0x" << format(identifierStart, duid.m_blob.cend());
+        break;
+    }
+    case Duid::Type::LL: {
+        os << "DUID-LL";
+        os << " HWtype: " << fold16(duid.m_blob.cbegin());
+        auto identifierStart = duid.m_blob.cbegin() + Duid::Offset::LL;
+        os << " Identifier: 0x" << format(identifierStart, duid.m_blob.cend());
+        break;
+    }
+    case Duid::Type::UUID: {
+        os << "DUID-UUID";
+        auto identifierStart = duid.m_blob.cbegin();
+        os << " UUID: 0x" << format(identifierStart, duid.m_blob.cend());
+        break;
+    }
+    }
+    return os;
+}
+
 } // namespace ns3
